<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>physicallayer/persist.h Source File (CEL: Crystal Entity Layer 2.0 Public API Reference)</title>
<link href="tabs.css" rel="stylesheet" type="text/css">
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<table border="0" cellpadding="0" cellspacing="0" width="100%" class="head">
 <tr height="59">
  <td class="head" width="202" valign="bottom" style="padding-left:0;"><a href="http://cel.crystalspace3d.org/"><img src="celblur.png" width="210" height="59" alt="CEL" border="0"></a></td>
  <td class="head"><h2>Public API Reference</h2></td>
 </tr>
 <tr height="11">
  <td colspan="2" class="headshadow" valign="top" style="padding-left:0;"><img src="celshadow.png" width="9" height="11" alt="" border="0"></td>
 </tr>
</table>
<div class="content">
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">physicallayer/persist.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    Crystal Space Entity Layer</span>
<a name="l00003"></a>00003 <span class="comment">    Copyright (C) 2001 by Jorrit Tyberghein</span>
<a name="l00004"></a>00004 <span class="comment">  </span>
<a name="l00005"></a>00005 <span class="comment">    This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment">    modify it under the terms of the GNU Library General Public</span>
<a name="l00007"></a>00007 <span class="comment">    License as published by the Free Software Foundation; either</span>
<a name="l00008"></a>00008 <span class="comment">    version 2 of the License, or (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment">  </span>
<a name="l00010"></a>00010 <span class="comment">    This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00013"></a>00013 <span class="comment">    Library General Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment">  </span>
<a name="l00015"></a>00015 <span class="comment">    You should have received a copy of the GNU Library General Public</span>
<a name="l00016"></a>00016 <span class="comment">    License along with this library; if not, write to the Free</span>
<a name="l00017"></a>00017 <span class="comment">    Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,</span>
<a name="l00018"></a>00018 <span class="comment">    MA 02111-1307, USA.</span>
<a name="l00019"></a>00019 <span class="comment">*/</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __CEL_PL_PERSIST__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __CEL_PL_PERSIST__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/cstypes_8h.html">cstypes.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/scf_8h.html">csutil/scf.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/util_8h.html">csutil/util.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/csutil_2array_8h.html">csutil/array.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;physicallayer/datatype.h&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">struct </span><a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>;
<a name="l00032"></a>00032 <span class="keyword">struct </span><a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>;
<a name="l00033"></a>00033 <span class="keyword">struct </span><a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiFile.html">iFile</a>;
<a name="l00034"></a>00034 <span class="keyword">struct </span><a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>;
<a name="l00035"></a>00035 
<a name="l00057"></a>00057 <span class="keyword">enum</span> celPersistenceType
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   CEL_PERSIST_TYPE_UNDEF = 0,
<a name="l00060"></a>00060   CEL_PERSIST_TYPE_RECORD,
<a name="l00061"></a>00061   CEL_PERSIST_TYPE_RECORD_FIRST_PASS,
<a name="l00062"></a>00062   CEL_PERSIST_TYPE_SERVER_CONTROL,
<a name="l00063"></a>00063   CEL_PERSIST_TYPE_CLIENT_CONTROL,
<a name="l00064"></a>00064   CEL_PERSIST_TYPE_SERVER_FORCING
<a name="l00065"></a>00065 };
<a name="l00066"></a>00066 
<a name="l00080"></a>00080 <span class="keyword">enum</span> celPersistenceResult
<a name="l00081"></a>00081 {
<a name="l00082"></a>00082   CEL_PERSIST_RESULT_UNDEF = 0,
<a name="l00083"></a>00083   CEL_PERSIST_RESULT_OK,
<a name="l00084"></a>00084   CEL_PERSIST_RESULT_CHEAT_SUSPICIOUS,
<a name="l00085"></a>00085   CEL_PERSIST_RESULT_CHEAT_CLEAR,
<a name="l00086"></a>00086   CEL_PERSIST_RESULT_ERROR,
<a name="l00087"></a>00087   CEL_PERSIST_RESULT_UNKNOWN_PC
<a name="l00088"></a>00088 };
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="structiCelDataBuffer.html">00093</a> <span class="keyword">struct </span><a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00094"></a>00094 {
<a name="l00095"></a>00095   SCF_INTERFACE (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>, 0, 0, 2);
<a name="l00096"></a>00096 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">long</span> <a class="code" href="structiCelDataBuffer.html#a5ed1b0f4c5978ad6773178256b414ee4" title="Get a serial number for this data.">GetSerialNumber</a> () <span class="keyword">const</span> = 0;
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelDataBuffer.html#a7d2c994b631a175d1530254f982cd3da" title="Get the number of data entries.">GetDataCount</a> () <span class="keyword">const</span> = 0;
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#ac1071585c5549ef17aa0488b6ed82752" title="Reset the internal read counter.">Reset</a> () = 0;
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> () = 0;
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> (<span class="keywordtype">size_t</span> idx) = 0;
<a name="l00123"></a>00123 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> () = 0;
<a name="l00128"></a>00128 
<a name="l00130"></a><a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1">00130</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<span class="keywordtype">bool</span> v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa79c2d3de4fcd200458c406f40b2ae64">int8</a> v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa0d0fdc87fd135ef2bedb030901cdb9c">int16</a> v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gab7903878916593daecbeb95b98115ab0">int32</a> v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gac2a9e79eb120216f855626495b7bd18a">uint16</a> v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00136"></a>00136   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00137"></a>00137   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<span class="keywordtype">float</span> v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp; v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00139"></a>00139   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00140"></a>00140   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<span class="keyword">const</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp; v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00141"></a>00141   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<span class="keyword">const</span> <span class="keywordtype">char</span>* v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00143"></a>00143   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelDataBuffer.html#a9ba8d453634f1b459d3b8ff78246bcc1" title="Convenience methods to add specific types of data.">Add</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;<a class="code" href="structcelData.html#ab9923d0fceb11a4e054e49fb212e1aed" title="Initialize and set the value.">Set</a> (v); }
<a name="l00144"></a>00144   <span class="keyword">virtual</span> <span class="keywordtype">void</span> AddAction (<span class="keyword">const</span> <span class="keywordtype">char</span>* v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;SetAction (v); }
<a name="l00145"></a>00145   <span class="keyword">virtual</span> <span class="keywordtype">void</span> AddIBase (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* v) { <a class="code" href="structiCelDataBuffer.html#afaad25c5c32be4d6986ccc5a60e3b7ff" title="Add a data entry.">AddData</a> ()-&gt;SetIBase (v); }
<a name="l00146"></a>00146 
<a name="l00148"></a><a class="code" href="structiCelDataBuffer.html#aa6717cd01363b1bb5248f53973dd6f07">00148</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelDataBuffer.html#aa6717cd01363b1bb5248f53973dd6f07" title="Convenience methods to get specific types of data.">GetBool</a> ()
<a name="l00149"></a>00149   {
<a name="l00150"></a>00150     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00151"></a>00151     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_BOOL) ? cd-&gt;value.bo : <span class="keyword">false</span>;
<a name="l00152"></a>00152   }
<a name="l00153"></a>00153   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa79c2d3de4fcd200458c406f40b2ae64">int8</a> GetInt8 ()
<a name="l00154"></a>00154   {
<a name="l00155"></a>00155     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00156"></a>00156     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_BYTE) ? cd-&gt;value.b : 0;
<a name="l00157"></a>00157   }
<a name="l00158"></a>00158   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#ga33a5e996e7a90acefb8b1c0bea47e365">uint8</a> GetUInt8 ()
<a name="l00159"></a>00159   {
<a name="l00160"></a>00160     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00161"></a>00161     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_UBYTE) ? cd-&gt;value.ub : 0;
<a name="l00162"></a>00162   }
<a name="l00163"></a>00163   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gaa0d0fdc87fd135ef2bedb030901cdb9c">int16</a> GetInt16 ()
<a name="l00164"></a>00164   {
<a name="l00165"></a>00165     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00166"></a>00166     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_WORD) ? cd-&gt;value.w : 0;
<a name="l00167"></a>00167   }
<a name="l00168"></a>00168   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gac2a9e79eb120216f855626495b7bd18a">uint16</a> GetUInt16 ()
<a name="l00169"></a>00169   {
<a name="l00170"></a>00170     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00171"></a>00171     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_UWORD) ? cd-&gt;value.uw : 0;
<a name="l00172"></a>00172   }
<a name="l00173"></a>00173   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gab7903878916593daecbeb95b98115ab0">int32</a> GetInt32 ()
<a name="l00174"></a>00174   {
<a name="l00175"></a>00175     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00176"></a>00176     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_LONG) ? cd-&gt;value.l : 0;
<a name="l00177"></a>00177   }
<a name="l00178"></a>00178   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/group__util.html#gacbd4acd0d29e2d6c43104827f77d9cd2">uint32</a> GetUInt32 ()
<a name="l00179"></a>00179   {
<a name="l00180"></a>00180     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00181"></a>00181     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_ULONG) ? cd-&gt;value.ul : 0;
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183   <span class="keyword">virtual</span> <span class="keywordtype">float</span> GetFloat ()
<a name="l00184"></a>00184   {
<a name="l00185"></a>00185     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00186"></a>00186     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_FLOAT) ? cd-&gt;value.f : 0.0f;
<a name="l00187"></a>00187   }
<a name="l00188"></a>00188   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiString.html">iString</a>* GetString ()
<a name="l00189"></a>00189   {
<a name="l00190"></a>00190     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00191"></a>00191     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_STRING) ? cd-&gt;value.s : (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiString.html">iString</a>*)0;
<a name="l00192"></a>00192   }
<a name="l00193"></a>00193   <span class="keyword">virtual</span> <span class="keywordtype">void</span> GetVector2 (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html">csVector2</a>&amp; v)
<a name="l00194"></a>00194   {
<a name="l00195"></a>00195     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00196"></a>00196     <span class="keywordflow">if</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_VECTOR2)
<a name="l00197"></a>00197     { v.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html#acf4ee25489c98e6b7b7a460c4edd4ac6">x</a> = cd-&gt;value.v.x; v.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html#af736730a67b9ee807f1455da3d2be188">y</a> = cd-&gt;value.v.y; }
<a name="l00198"></a>00198     <span class="keywordflow">else</span> v.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html#acf4ee25489c98e6b7b7a460c4edd4ac6">x</a> = v.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector2.html#af736730a67b9ee807f1455da3d2be188">y</a> = 0;
<a name="l00199"></a>00199   }
<a name="l00200"></a>00200   <span class="keyword">virtual</span> <span class="keywordtype">void</span> GetVector3 (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsVector3.html">csVector3</a>&amp; v)
<a name="l00201"></a>00201   {
<a name="l00202"></a>00202     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00203"></a>00203     <span class="keywordflow">if</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_VECTOR3)
<a name="l00204"></a>00204     { v.x = cd-&gt;value.v.x; v.y = cd-&gt;value.v.y; v.z = cd-&gt;value.v.z; }
<a name="l00205"></a>00205     <span class="keywordflow">else</span> v.x = v.y = v.z = 0;
<a name="l00206"></a>00206   }
<a name="l00207"></a>00207   <span class="keyword">virtual</span> <span class="keywordtype">void</span> GetColor (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsColor.html">csColor</a>&amp; v)
<a name="l00208"></a>00208   {
<a name="l00209"></a>00209     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00210"></a>00210     <span class="keywordflow">if</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_COLOR)
<a name="l00211"></a>00211     {
<a name="l00212"></a>00212       v.red = cd-&gt;value.col.red;
<a name="l00213"></a>00213       v.green = cd-&gt;value.col.green;
<a name="l00214"></a>00214       v.blue = cd-&gt;value.col.blue;
<a name="l00215"></a>00215     }
<a name="l00216"></a>00216     <span class="keywordflow">else</span> v.red = v.green= v.blue = 0;
<a name="l00217"></a>00217   }
<a name="l00218"></a>00218   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* GetPC ()
<a name="l00219"></a>00219   {
<a name="l00220"></a>00220     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00221"></a>00221     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_PCLASS)
<a name="l00222"></a>00222         ? cd-&gt;value.pc
<a name="l00223"></a>00223         : (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>*)0;
<a name="l00224"></a>00224   }
<a name="l00225"></a>00225   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* GetEntity ()
<a name="l00226"></a>00226   {
<a name="l00227"></a>00227     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00228"></a>00228     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_ENTITY)
<a name="l00229"></a>00229         ? cd-&gt;value.ent
<a name="l00230"></a>00230         : (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>*)0;
<a name="l00231"></a>00231   }
<a name="l00232"></a>00232   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>* GetIBase ()
<a name="l00233"></a>00233   {
<a name="l00234"></a>00234     <a class="code" href="structcelData.html" title="Typed data for CEL.">celData</a>* cd = <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ();
<a name="l00235"></a>00235     <span class="keywordflow">return</span> (cd &amp;&amp; cd-&gt;type == CEL_DATA_IBASE) ? cd-&gt;value.ibase : (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>*)0;
<a name="l00236"></a>00236   }
<a name="l00237"></a>00237   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> GetDebugInfo ()
<a name="l00238"></a>00238   {
<a name="l00239"></a>00239     <span class="keywordflow">if</span> (<a class="code" href="structiCelDataBuffer.html#a7d2c994b631a175d1530254f982cd3da" title="Get the number of data entries.">GetDataCount</a> () == 0) <span class="keywordflow">return</span> <span class="stringliteral">&quot;Data buffer: empty\n&quot;</span>;
<a name="l00240"></a>00240 
<a name="l00241"></a>00241     <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a> txt = <span class="stringliteral">&quot;Data buffer:\n&quot;</span>;
<a name="l00242"></a>00242     <span class="keywordtype">size_t</span> i = 0, count = <a class="code" href="structiCelDataBuffer.html#a7d2c994b631a175d1530254f982cd3da" title="Get the number of data entries.">GetDataCount</a> ();
<a name="l00243"></a>00243     <span class="keywordflow">for</span> ( ; i &lt; count; i++)
<a name="l00244"></a>00244       txt.<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsStringBase.html#af6b05c0f5327d0ef2d7965da77a0857d">AppendFmt</a>(<span class="stringliteral">&quot;\t%s\n&quot;</span>, <a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> (i)-&gt;GetDebugInfo ().<a class="code" href="structiCelDataBuffer.html#a52b44569c137762edeade31567a13005" title="Get the next data entry.">GetData</a> ());
<a name="l00245"></a>00245 
<a name="l00246"></a>00246     <span class="keywordflow">return</span> txt;
<a name="l00247"></a>00247   }
<a name="l00248"></a>00248 };
<a name="l00249"></a>00249 
<a name="l00256"></a><a class="code" href="structiCelPersistentDataList.html">00256</a> <span class="keyword">struct </span><a class="code" href="structiCelPersistentDataList.html" title="A list of persistent data for all the property classes of an entity.">iCelPersistentDataList</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00257"></a>00257 {
<a name="l00258"></a>00258   SCF_INTERFACE (<a class="code" href="structiCelPersistentDataList.html" title="A list of persistent data for all the property classes of an entity.">iCelPersistentDataList</a>, 0, 0, 1);
<a name="l00259"></a>00259 
<a name="l00263"></a>00263   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelPersistentDataList.html#ac151ef95ba307c6a0fc9a160ec0d8057" title="Return the number of entries in this list.">GetCount</a> () <span class="keyword">const</span> = 0;
<a name="l00264"></a>00264 
<a name="l00274"></a>00274   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPersistentDataList.html#a810a02d4a18348bcd1236b6b12988ca2" title="To get the persistent data at the specified position.">GetPersistentData</a> (<span class="keywordtype">size_t</span> idx, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelDataBuffer&gt;</a>&amp; databuf, 
<a name="l00275"></a>00275         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; pc_name, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; pc_tag) <span class="keyword">const</span> = 0;
<a name="l00276"></a>00276 
<a name="l00286"></a>00286   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelPersistentDataList.html#a6dbe20e00629f71d57aabb00697e4321" title="To add a new persistent data buffer.">AddPersistentData</a> (<a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsRef.html">csRef&lt;iCelDataBuffer&gt;</a>&amp; databuf, 
<a name="l00287"></a>00287         <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; pc_name, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsString.html">csString</a>&amp; pc_tag) = 0;
<a name="l00288"></a>00288 };
<a name="l00289"></a>00289 
<a name="l00297"></a><a class="code" href="structiCelLocalEntitySet.html">00297</a> <span class="keyword">struct </span><a class="code" href="structiCelLocalEntitySet.html" title="A local entity set define the set of entities that are considered &#39;local&#39; to the saved file...">iCelLocalEntitySet</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00298"></a>00298 {
<a name="l00299"></a>00299   SCF_INTERFACE (<a class="code" href="structiCelLocalEntitySet.html" title="A local entity set define the set of entities that are considered &#39;local&#39; to the saved file...">iCelLocalEntitySet</a>, 0, 0, 1);
<a name="l00300"></a>00300 
<a name="l00302"></a>00302   <span class="keyword">virtual</span> <span class="keywordtype">size_t</span> <a class="code" href="structiCelLocalEntitySet.html#ab28e74b544fe08f6193895ee9fc077d0" title="Number of entities managed by this set.">GetEntityCount</a> () <span class="keyword">const</span> = 0;
<a name="l00303"></a>00303   
<a name="l00305"></a>00305   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* <a class="code" href="structiCelLocalEntitySet.html#a4b8beacae23205368abb935d5a23fc56" title="Get the specified entity.">GetEntity</a> (<span class="keywordtype">size_t</span> idx) <span class="keyword">const</span> = 0;
<a name="l00306"></a>00306 
<a name="l00308"></a>00308   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="structiCelLocalEntitySet.html#a7f8f6bae04f5915b58a0492681bbf5a0" title="Add an entity to the local set.">AddEntity</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00309"></a>00309 
<a name="l00311"></a>00311   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelLocalEntitySet.html#a379dc3db21e2e5222b91b1a43514013c" title="Test if an entity is local (is in this set).">IsLocal</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00313"></a>00313   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelLocalEntitySet.html#a379dc3db21e2e5222b91b1a43514013c" title="Test if an entity is local (is in this set).">IsLocal</a> (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc) = 0;
<a name="l00314"></a>00314 
<a name="l00320"></a>00320   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> <a class="code" href="structiCelLocalEntitySet.html#a479c8e3693afb2897c2e45db3a76b915" title="This routine will be called by the persistence layer whenever it needs to save a non-local entity...">SaveExternalEntity</a> (<a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* entity) = 0;
<a name="l00321"></a>00321 
<a name="l00327"></a>00327   <span class="keyword">virtual</span> <a class="code" href="structiCelEntity.html" title="This is an entity in the CEL layer at the PL (physical layer) side.">iCelEntity</a>* <a class="code" href="structiCelLocalEntitySet.html#a235e59357aee268fb3948b31b64276d4" title="This routine will be called by the persistence layer whenever it needs to find a non-local entity...">FindExternalEntity</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00328"></a>00328 
<a name="l00334"></a>00334   <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/classcsPtr.html">csPtr&lt;iCelDataBuffer&gt;</a> <a class="code" href="structiCelLocalEntitySet.html#a9f1d7fb6b0c5888a4838c5f534b757f4" title="This routine will be called by the persistence layer whenever it needs to save a non-local property c...">SaveExternalPC</a> (<a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* pc) = 0;
<a name="l00335"></a>00335 
<a name="l00341"></a>00341   <span class="keyword">virtual</span> <a class="code" href="structiCelPropertyClass.html" title="This is a property class for an entity.">iCelPropertyClass</a>* <a class="code" href="structiCelLocalEntitySet.html#a7a21fc23921a1ef7875c5b730df6e863" title="This routine will be called by the persistence layer whenever it needs to find a non-local property c...">FindExternalPC</a> (<a class="code" href="structiCelDataBuffer.html" title="This interface describes persistable data.">iCelDataBuffer</a>* databuf) = 0;
<a name="l00342"></a>00342 };
<a name="l00343"></a>00343 
<a name="l00348"></a><a class="code" href="structiCelPersistence.html">00348</a> <span class="keyword">struct </span><a class="code" href="structiCelPersistence.html" title="This interface describes a module that can persist CEL data.">iCelPersistence</a> : <span class="keyword">public</span> <span class="keyword">virtual</span> <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiBase.html">iBase</a>
<a name="l00349"></a>00349 {
<a name="l00350"></a>00350   SCF_INTERFACE (<a class="code" href="structiCelPersistence.html" title="This interface describes a module that can persist CEL data.">iCelPersistence</a>, 0, 1, 1);
<a name="l00351"></a>00351 
<a name="l00361"></a>00361   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPersistence.html#aa13b5a584d201c2abf8f35094e7a4096" title="Load a local entity set.">Load</a> (<a class="code" href="structiCelLocalEntitySet.html" title="A local entity set define the set of entities that are considered &#39;local&#39; to the saved file...">iCelLocalEntitySet</a>* <span class="keyword">set</span>, <span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00362"></a>00362 
<a name="l00371"></a>00371   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPersistence.html#a208a905d9d78132c4559ccb13c3d7915" title="Save a local entity set.">Save</a> (<a class="code" href="structiCelLocalEntitySet.html" title="A local entity set define the set of entities that are considered &#39;local&#39; to the saved file...">iCelLocalEntitySet</a>* <span class="keyword">set</span>, <span class="keyword">const</span> <span class="keywordtype">char</span>* name) = 0;
<a name="l00372"></a>00372 
<a name="l00380"></a>00380   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPersistence.html#aa13b5a584d201c2abf8f35094e7a4096" title="Load a local entity set.">Load</a> (<a class="code" href="structiCelLocalEntitySet.html" title="A local entity set define the set of entities that are considered &#39;local&#39; to the saved file...">iCelLocalEntitySet</a>* <span class="keyword">set</span>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiFile.html">iFile</a>* file) = 0;
<a name="l00381"></a>00381 
<a name="l00388"></a>00388   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="structiCelPersistence.html#a208a905d9d78132c4559ccb13c3d7915" title="Save a local entity set.">Save</a> (<a class="code" href="structiCelLocalEntitySet.html" title="A local entity set define the set of entities that are considered &#39;local&#39; to the saved file...">iCelLocalEntitySet</a>* <span class="keyword">set</span>, <a class="codeRef" doxygen="crystalspace.tag:http://www.crystalspace3d.org/docs/online/api/" href="http://www.crystalspace3d.org/docs/online/api/structiFile.html">iFile</a>* file) = 0;
<a name="l00389"></a>00389 };
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 <span class="preprocessor">#endif // __CEL_PL_PERSIST__</span>
</pre></div></div><!-- contents -->
<hr size="1"><address><small>Generated for CEL: Crystal Entity Layer 2.0 by 
<a href="http://www.doxygen.org/index.html">doxygen</a> 1.7.6.1 
</small></address> </div></body> </html>
